// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "WQuick.h"

#include "MainFrm.h"
#include "WQuickDoc.h"
#include "WQuickHtmlView.h"
#include "WQuickFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_MOVING()
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	// ZU ERLEDIGEN: Hier Code zur Member-Initialisierung einfgen
	//MessageBox("CMainFrame()","CMainFrame()",MB_OK);
}

CMainFrame::~CMainFrame()
{
//	MessageBox("~CMainFrame()","~CMainFrame()",MB_OK);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
  /*return m_wndSplitter.Create(this,
	2, 2,               // ZU ERLEDIGEN: Spalten- und Zeilenzahl festlegen
	CSize(10, 10),      // ZU ERLEDIGEN: Minimale Gre der Bearbeitungsflche festlegen
	pContext);*/
  m_wndSplitter.CreateStatic(this,2,1);
  m_wndSplitter.CreateView(1,0,RUNTIME_CLASS(CWQuickHtmlView),CSize(450,200),pContext);
  m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CWQuickFormView),CSize(450,20),pContext);
  
  ((CWQuickHtmlView *) m_wndSplitter.GetPane(1,0))->m_form=(CWQuickFormView*)m_wndSplitter.GetPane(0,0);
  ((CWQuickHtmlView *) m_wndSplitter.GetPane(1,0))->CMFrm=this;
  ((CWQuickHtmlView *) m_wndSplitter.GetPane(1,0))->TimerValue=SetTimer(1,100,NULL);
  return TRUE;
};

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.
	cs.cx=450;
	cs.cy=300;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler


void CMainFrame::OnTimer(UINT nIDEvent) 
{
    if (OpenClipboard())
	{
	  CString temp=(char *)GetClipboardData(CF_TEXT);
		CloseClipboard();
		if (temp!=m_LastClipboard)
		{
			((CWQuickFormView *) m_wndSplitter.GetPane(0,0))->m_SearchExpression=temp;
			m_LastClipboard=temp;
			((CWQuickFormView *) m_wndSplitter.GetPane(0,0))->UpdateData(FALSE);
		}
	}
	if (m_wndSplitter.GetPane(0,0)!=NULL)
	{
		((CWQuickFormView *) m_wndSplitter.GetPane(0,0))->Search();
	}
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnMoving(UINT fwSide, LPRECT pRect) 
{
	CFrameWnd::OnMoving(fwSide, pRect);
	
	CRect screen, newWnd;

	SystemParametersInfo(SPI_GETWORKAREA, 0, &screen, 0);
	newWnd=*pRect;
	if(pRect->top < screen.top+10)
	{
		newWnd.top = screen.top;
		newWnd.bottom = newWnd.top+CRect(pRect).Height();
	}
	if(pRect->bottom > screen.bottom-10)
	{
		newWnd.bottom = screen.bottom;
		newWnd.top = newWnd.bottom-CRect(pRect).Height();
	}
	if(pRect->left < screen.left+10)
	{
		newWnd.left = screen.left;
		newWnd.right = newWnd.left+CRect(pRect).Width();
	}
	if(pRect->right > screen.right-10)
	{
		newWnd.right = screen.right;
		newWnd.left = newWnd.right-CRect(pRect).Width();
	}
	SetWindowPos(&wndTop, newWnd.left, newWnd.top, newWnd.Width(),
		newWnd.Height(), SWP_NOZORDER);
}

void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
/*	CRect rect;

	GetWindowRect(&rect);
	if(rect.left != x || rect.top != y)
	{
		SetWindowPos(&wndTop, x, y, rect.Width(),
			rect.Height(), SWP_NOZORDER);
	}*/
}
